/***********************************************************
 * $Id$
 *
 * FancyLibs sane wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSANEDEVICEINFO_H_
#define FANCYSANEDEVICEINFO_H_

#include <fancysane.h>
#include <fancyobject.h>

#include <string>

namespace Fancy {

class List;

namespace Sane {

class FANCYSANE_API SaneDeviceInfo : virtual public Fancy::Object
{
    std::string name;
    std::string vendor;
    std::string model;
    std::string type;

public:
    typedef Fancy::ObjPtr<SaneDeviceInfo> ptr_t;

    static ptr_t newInstance();

    const std::string &getName() const { return this->name; }
    void setName(const std::string &_name) { this->name = _name; }


    const std::string &getVendor() const { return this->vendor; }
    void setVendor(const std::string &_vendor) { this->vendor = _vendor;}


    const std::string &getModel() const { return this->model; }
    void setModel(const std::string &_model) { this->model = _model;}

    const std::string &getType() const { return this->type; }
    void setType(const std::string &_type) { this->type = _type;}

    virtual std::string toString() const;

protected:
    SaneDeviceInfo();
    virtual ~SaneDeviceInfo();
};

}}// end namespaces

#endif
