/***********************************************************
 * $Id$
 *
 * FancyLibs sane wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSANE_LOG_H
#define FANCYSANE_LOG_H

#include <fancysane.h>

#include <fancylog.h>

// facility "fancysanelib"
#define  FANCYSANE_LOG           (1<<0)
// facility "fancysanetool"
#define  FANCYSANE_LOG_TOOL      (1<<1)
// facility "fancysaneserver"
#define  FANCYSANE_LOG_SERVER    (1<<2)

namespace Fancy {
namespace Sane {
  extern FANCYSANE_API fancylog_service *log_service;

  // parse for logging cmdline args and filter out recognized options.
  void FANCYSANE_API fancylog_parse_arg (int *argc, char **argv);

  inline void vfancylog (int facility,
                         int priority, const char *fmt, va_list ap)
  {
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
  }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));

#endif

  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
  {
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
  }
}
}

#endif // ! FANCYSANE_LOG_H
